/*

*/

/**
This package contains an implementation of the tree
algebraic data type.
<pre>
   Tree<T> = T List<Tree<T>>
</pre>
This definition of a tree does not allow for an empty tree.
Our main use for trees will be as parse trees, expression
trees, and abstract syntax trees. None of these ever need
to be empty. By not allowing for an empty tree, we can
make the definition and implementation of the {@link Tree}
type as simple as possible.
<p>
When a tree's list of sub trees is empty, the tree is a
leaf node.
<p>
{@link Tree} is an interface that declares what a {@link Tree}
implementation must be able to do. {@link Tree} also implements
several methods ("default" methods) that are then common to all
{@link Tree} implementations.
<p>
{@link LinkedTree} shows how to implements the {@link Tree}
interface as a linked data structure. {@link LinkedTree}
implements a {@link Tree} object as two references, a reference
to a root object and a reference to a {@link java.util.List}
of {@link Tree}. The implementation enforces the invariant
that these two references are never {@code null}.
*/
package tree;
